/** 
 * @file DiffFileData.h
 *
 * @brief Declaration for DiffFileData class.
 *
 * @date  Created: 2003-08-22
 */
// RCS ID line follows -- this is updated by CVS
// $Id: DiffFileData.h 4075 2007-01-24 18:41:49Z kimmov $

#ifndef _DIFFFILEDATA_H_
#define _DIFFFILEDATA_H_

// forward declarations needed by DiffFileData
struct file_data;
class PrediffingInfo;
class CDiffContext;

/*struct FileHandle
{
	FileHandle() : m_fp(NULL) { }
	void Close() { if (m_fp) { fclose(m_fp); m_fp = NULL; } }
	~FileHandle() { Close(); }
  FileHandle& operator=(FILE * fp) {Close(); m_fp = fp; return *this;}
private:
	FILE * m_fp;
};*/

/**
 * @brief C++ container for the structure (file_data) used by diffutils' diff_2_files(...)
 */
struct DiffFileData
{
// class interface
  enum { DIFFS_UNKNOWN=-1, DIFFS_UNKNOWN_QUICKCOMPARE=-9 };
	static void SetDefaultCodepage(int defcp); // set codepage to assume for all unknown files


// instance interface

	DiffFileData(CDiffContext *pCtxt = NULL);
	~DiffFileData();

	void SetDisplayFilepaths(LPCTSTR szTrueFilepath1, LPCTSTR szTrueFilepath2);
	bool OpenFiles(LPCTSTR szFilepath1, LPCTSTR szFilepath2);
	void Reset();
	void Close() { Reset(); }
  bool Diff2Files(change * &diffs,
		int *bin_status = NULL, bool bMovedBlocks = false, int *bin_file = NULL);
  static bool RegExpFilter(FilterList *pFilterList, int StartPos, int EndPos, int FileNo);
  int prepAndCompareTwoFiles(DIFFITEM &di);

// Data (public)
	file_data * m_inf;
	bool m_used; // whether m_inf has real data
	FileLocation m_FileLocation[2];
	FileTextStats m_textStats0, m_textStats1;
  int m_ndiffs;
	int m_ntrivialdiffs;
  CDiffContext *m_pCtx;
  bool m_bSearchMovedBlocks;

	CString m_sDisplayFilepath[2];
	struct UniFileBom // detect unicode file and quess encoding
	{
		UniFileBom(int); // initialize from file descriptor
		int size;
		int unicoding;
		unsigned char buffer[4];
	};

private:
  int diffutils_compare_files();
	int byte_compare_files();

	//bool Filepath_Transform(FileLocation & fpenc, const CString & filepath, CString & filepathTransformed,
	//	const CString & filteredFilenames, PrediffingInfo * infoPrediffer, int fd);
  bool Filepath_Transform(int side, const CString &filepath, CString &filepathTransformed,
		const CString &filteredFilenames, PrediffingInfo *infoPrediffer);
	void GuessEncoding_from_buffer_in_DiffContext(int side);
	static void GuessEncoding_from_buffer(FileLocation & fpenc, LPCSTR *data, int count);
	//void GuessEncoding_from_FileLocation(FileLocation & fpenc);
  void GuessEncoding_from_FileLocation(int side);
	bool DoOpenFiles();
  void CopyDiffutilTextStats();
  void GetComparePaths(const DIFFITEM &di, CString &left, CString &right);
};

//void GetComparePaths(CDiffContext *pCtxt, const DIFFITEM &di, CString &left, CString &right);
//bool Unpack(CString &filepathTransformed,	const CString &filteredFilenames, PackingInfo *infoUnpacker);

#endif // _DIFFFILEDATA_H_
