///////////////////////////////////////////////////////////////////////////
//  File:       cplusplus.cpp
//  Version:    1.2.0.5
//  Created:    29-Dec-1998
//
//  Copyright:  Stcherbatchenko Andrei
//  E-mail:     windfall@gmx.de
//
//  Implementation of the CCrystalEditView class, a part of the Crystal Edit -
//  syntax coloring text editor.
//
//  You are free to use or modify this code to the following restrictions:
//  - Acknowledge me somewhere in your about box, simple "Parts of code by.."
//  will be enough. If you can't (or don't want to), contact me personally.
//  - LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//  16-Aug-99
//      Ferdinand Prantl:
//  +   FEATURE: corrected bug in syntax highlighting C comments
//  +   FEATURE: extended levels 1- 4 of keywords in some languages
//
//  ... it's being edited very rapidly so sorry for non-commented
//        and maybe "ugly" code ...
////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "../ccrystaltextview.h"
#include "../ccrystaltextbuffer.h"
#include "syntaxbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//  C++ keywords (MSVC5.0 + POET5.0)
/*static LPTSTR s_apszCppKeywordList[] =
  {
    //_T ("_asm"),
    _T ("__asm"),
    //_T ("_far16"),
    //_T ("__far16"),
    _T ("enum"),
    _T ("__multiple_inheritance"),
    _T ("template"),
    _T ("auto"),
    _T ("__except"),
    _T ("__single_inheritance"),
    _T ("this"),
    _T ("__based"),
    _T ("explicit"),
    _T ("__virtual_inheritance"),
    _T ("thread"),
    _T ("bool"),
    _T ("extern"),
    _T ("mutable"),
    _T ("throw"),
    _T ("break"),
    _T ("false"),
    _T ("naked"),
    _T ("true"),
    _T ("case"),
    _T ("_fastcall"),
    _T ("__fastcall"),
    _T ("namespace"),
    _T ("try"),
    _T ("catch"),
    _T ("__finally"),
    _T ("new"),
    _T ("__try"),
    _T ("__cdecl"),
    _T ("__pascal"),
    _T ("_cdecl"),
    _T ("_pascal"),
    _T ("float"),
    _T ("operator"),
    _T ("typedef"),
    _T ("char"),
    _T ("for"),
    _T ("private"),
    _T ("typeid"),
    _T ("class"),
    _T ("friend"),
    _T ("protected"),
    _T ("typename"),
    _T ("const"),
    _T ("goto"),
    _T ("public"),
    _T ("union"),
    _T ("const_cast"),
    _T ("if"),
    _T ("register"),
    _T ("unsigned"),
    _T ("continue"),
    _T ("inline"),
    _T ("reinterpret_cast"),
    _T ("using"),
    _T ("__declspec"),
    _T ("__inline"),
    _T ("return"),
    _T ("uuid"),
    _T ("default"),
    _T ("int"),
    _T ("short"),
    _T ("__uuidof"),
    _T ("delete"),
    _T ("__int8"),
    _T ("signed"),
    _T ("virtual"),
    _T ("_export"),
    _T ("__export"),
    _T ("dllexport"),
    _T ("__int16"),
    _T ("sizeof"),
    _T ("void"),
    _T ("dllimport"),
    _T ("__int32"),
    _T ("static"),
    _T ("volatile"),
    _T ("do"),
    _T ("__int64"),
    _T ("static_cast"),
    _T ("wmain"),
    _T ("double"),
    _T ("__leave"),
    _T ("_stdcall"),
    _T ("__stdcall"),
    _T ("_syscall"),
    _T ("__syscall"),
    _T ("while"),
    _T ("dynamic_cast"),
    _T ("long"),
    _T ("struct"),
    _T ("xalloc"),
    _T ("else"),
    _T ("main"),
    _T ("switch"),
    _T ("interface"),
    //  Added by a.s.
    _T ("persistent"),
    _T ("_persistent"),
    _T ("transient"),
    _T ("depend"),
    _T ("ondemand"),
    _T ("transient"),
    _T ("cset"),
    _T ("useindex"),
    _T ("indexdef"),
    NULL
  };*/
//VS 2005
static LPTSTR s_apszCppKeywordList[] =
{
  _T("abstract"),
  _T("__alignof"),
  _T("array"),
  _T("__asm"),
  _T("__assume"),
  _T("__based"),
  _T("bool"),
  _T("break"),
  _T("case"),
  _T("catch"),
  _T("__cdecl"),
  _T("char"),
  _T("class"),
  _T("const"),
  _T("const_cast"),
  _T("continue"),
  _T("__declspec"),
  _T("default"),
  _T("delegate"),
  _T("delete"),
  _T("do"),
  _T("double"),
  _T("dynamic_cast"),
  _T("else"),
  _T("enum"),
  _T("event"),
  _T("__event"),
  _T("__except"),
  _T("explicit"),
  _T("extern"),
  _T("false"),
  _T("__fastcall"),
  _T("__finally"),
  _T("finally"),
  _T("float"),
  _T("for"),
  _T("each"),
  _T("in"),
  _T("__forceinline"),
  _T("friend"),
  _T("friend_as"),
  _T("gcnew"),
  _T("generic"),
  _T("goto"),
  _T("__hook"),
  _T("__identifier"),
  _T("if"),
  _T("__if_exists"),
  _T("__if_not_exists"),
  _T("initonly"),
  _T("__inline"),
  _T("inline"),
  _T("int"),
  _T("__int8"),
  _T("__int16"),
  _T("__int32"),
  _T("__int64"),
  _T("__interface"),
  _T("interface"),
  _T("interior_ptr"),
  _T("__leave"),
  _T("literal"),
  _T("long"),
  _T("__m64"),
  _T("__m128"),
  _T("__m128d"),
  _T("__m128i"),
  _T("__multiple_inheritance"),
  _T("mutable"),
  _T("namespace"),
  _T("new"),
  _T("__noop"),
  _T("nullptr"),
  _T("operator"),
  _T("private"),
  _T("property"),
  _T("protected"),
  _T("public"),
  _T("__raise"),
  _T("ref"),
  _T("register"),
  _T("reinterpret_cast"),
  _T("return"),
  _T("safecast"),
  _T("sealed"),
  _T("short"),
  _T("signed"),
  _T("__single_inheritance"),
  _T("sizeof"),
  _T("static"),
  _T("static_cast"),
  _T("__stdcall"),
  _T("struct"),
  _T("__super"),
  _T("switch"),
  _T("template"),
  _T("this"),
  _T("throw"),
  _T("true"),
  _T("try"),
  _T("__try"),
  _T("typedef"),
  _T("typeid"),
  _T("typename"),
  _T("__unaligned"),
  _T("__unhook"),
  _T("union"),
  _T("unsigned"),
  _T("using"),
  _T("__uuidof"),
  _T("value"),
  _T("virtual"),
  _T("__virtual_inheritance"),
  _T("void"),
  _T("volatile"),
  _T("__w64"),
  _T("__wchar_t"),
  _T("wchar_t"),
  _T("while"),
  NULL
};

static LPTSTR s_apszUser1KeywordList[] =
  {
    _T ("LPTSTR"),
    _T ("LPCTSTR"),
    _T ("LPWSTR"),
    _T ("LPCWSTR"),
    _T ("LPTSTR"),
    _T ("LPCTSTR"),
    _T ("CHAR"),
    _T ("WCHAR"),
    _T ("TCHAR"),
    _T ("BYTE"),
    _T ("BOOL"),
	_T ("VOID"),
	_T ("LONG"),
    _T ("TRUE"),
    _T ("FALSE"),
    _T ("INT"),
    _T ("UINT"),
    _T ("WORD"),
    _T ("DWORD"),
    _T ("WPARAM"),
    _T ("LPARAM"),
    _T ("LRESULT"),
	_T ("BSTR"),
	_T ("COLORREF"),
	_T ("LPCSTR"),
	_T ("LPSTR"),
	_T ("LPVOID"),
	_T ("LRESULT"),
	_T ("WNDPROC"),
	_T ("POSITION"),
	_T ("LPRECT"),
	_T ("HANDLE"),
    NULL
  };
   
class LangCpp : LangSyntaxBase
{
public:
  static BOOL IsCppNumber(LPCTSTR pszChars, int nLength);
  static BOOL IsCppKeyword(LPCTSTR pszChars, int nLength);
  static BOOL IsUser1Keyword (LPCTSTR pszChars, int nLength);
};

BOOL LangCpp::IsCppNumber(LPCTSTR pszChars, int nLength)
{
  return IsNumber2(pszChars, _T("0x"), _T("L U UL LL i64 ULL .L .F"), true, nLength);
}

BOOL LangCpp::IsCppKeyword(LPCTSTR pszChars, int nLength)
{
  return IsXKeyword(s_apszCppKeywordList, pszChars, false, nLength);
}

BOOL LangCpp::IsUser1Keyword (LPCTSTR pszChars, int nLength)
{
  return IsXKeyword(s_apszUser1KeywordList, pszChars, false, nLength);
}

DWORD CCrystalTextView::
ParseLineC (DWORD dwCookie, int nLineIndex, TEXTBLOCK * pBuf, int &nActualItems)
{
  int nLength = GetLineLength (nLineIndex);
  if (nLength == 0)
    return dwCookie & COOKIE_EXT_COMMENT;

  LPCTSTR pszChars = GetLineChars (nLineIndex);
  BOOL bFirstChar = (dwCookie & ~COOKIE_EXT_COMMENT) == 0;
  BOOL bRedefineBlock = TRUE;
  BOOL bWasCommentStart = FALSE;
  BOOL bDecIndex = FALSE;
  int nIdentBegin = -1;
  int nPrevI = -1;
  int I;
  for (I = 0;; nPrevI = I, I = CharNext(pszChars+I) - pszChars)
    {
      if (I == nPrevI)
        {
          // CharNext did not advance, so we're at the end of the string
          // and we already handled this character, so stop
          break;
        }

      if (bRedefineBlock)
        {
          int nPos = I;
          if (bDecIndex)
            nPos = nPrevI;
          if (dwCookie & (COOKIE_COMMENT | COOKIE_EXT_COMMENT))
            {
              DEFINE_BLOCK (nPos, COLORINDEX_COMMENT);
            }
          else if (dwCookie & (COOKIE_CHAR | COOKIE_STRING))
            {
              DEFINE_BLOCK (nPos, COLORINDEX_STRING);
            }
          else if (dwCookie & COOKIE_PREPROCESSOR)
            {
              DEFINE_BLOCK (nPos, COLORINDEX_PREPROCESSOR);
            }
          else
            {
              if (xisalnum (pszChars[nPos]) || pszChars[nPos] == '.' && nPos > 0 && (!xisalpha (*::CharPrev(pszChars, pszChars + nPos)) && !xisalpha (*::CharNext(pszChars + nPos))))
                {
                  DEFINE_BLOCK (nPos, COLORINDEX_NORMALTEXT);
                }
              else
                {
                  DEFINE_BLOCK (nPos, COLORINDEX_OPERATOR);
                  bRedefineBlock = TRUE;
                  bDecIndex = TRUE;
                  goto out;
                }
            }
          bRedefineBlock = FALSE;
          bDecIndex = FALSE;
        }
out:

      // Can be bigger than length if there is binary data
      // See bug #1474782 Crash when comparing SQL with with binary data
      if (I >= nLength)
        break;

      if (dwCookie & COOKIE_COMMENT)
        {
          DEFINE_BLOCK (I, COLORINDEX_COMMENT);
          dwCookie |= COOKIE_COMMENT;
          break;
        }

      //  String constant "...."
      if (dwCookie & COOKIE_STRING)
        {
          if (pszChars[I] == '"' && (I == 0 || I == 1 && pszChars[nPrevI] != '\\' || I >= 2 && (pszChars[nPrevI] != '\\' || pszChars[nPrevI] == '\\' && *::CharPrev(pszChars, pszChars + nPrevI) == '\\')))
            {
              dwCookie &= ~COOKIE_STRING;
              bRedefineBlock = TRUE;
            }
          continue;
        }

      //  Char constant '..'
      if (dwCookie & COOKIE_CHAR)
        {
          if (pszChars[I] == '\'' && (I == 0 || I == 1 && pszChars[nPrevI] != '\\' || I >= 2 && (pszChars[nPrevI] != '\\' || pszChars[nPrevI] == '\\' && *::CharPrev(pszChars, pszChars + nPrevI) == '\\')))
            {
              dwCookie &= ~COOKIE_CHAR;
              bRedefineBlock = TRUE;
            }
          continue;
        }

      //  Extended comment /*....*/
      if (dwCookie & COOKIE_EXT_COMMENT)
        {
          // if (I > 0 && pszChars[I] == '/' && pszChars[nPrevI] == '*')
          if ((I > 1 && pszChars[I] == '/' && pszChars[nPrevI] == '*' /*&& *::CharPrev(pszChars, pszChars + nPrevI) != '/'*/ && !bWasCommentStart) || (I == 1 && pszChars[I] == '/' && pszChars[nPrevI] == '*'))
            {
              dwCookie &= ~COOKIE_EXT_COMMENT;
              bRedefineBlock = TRUE;
            }
          bWasCommentStart = FALSE;
          continue;
        }

      if (I > 0 && pszChars[I] == '/' && pszChars[nPrevI] == '/')
        {
          DEFINE_BLOCK (nPrevI, COLORINDEX_COMMENT);
          dwCookie |= COOKIE_COMMENT;
          break;
        }

      //  Preprocessor directive #....
      if (dwCookie & COOKIE_PREPROCESSOR)
        {
          if (I > 0 && pszChars[I] == '*' && pszChars[nPrevI] == '/')
            {
              DEFINE_BLOCK (nPrevI, COLORINDEX_COMMENT);
              dwCookie |= COOKIE_EXT_COMMENT;
            }
          continue;
        }

      //  Normal text
      if (pszChars[I] == '"')
        {
          DEFINE_BLOCK (I, COLORINDEX_STRING);
          dwCookie |= COOKIE_STRING;
          continue;
        }
      if (pszChars[I] == '\'')
        {
          // if (I + 1 < nLength && pszChars[I + 1] == '\'' || I + 2 < nLength && pszChars[I + 1] != '\\' && pszChars[I + 2] == '\'' || I + 3 < nLength && pszChars[I + 1] == '\\' && pszChars[I + 3] == '\'')
          if (!I || !xisalnum (pszChars[nPrevI]))
            {
              DEFINE_BLOCK (I, COLORINDEX_STRING);
              dwCookie |= COOKIE_CHAR;
              continue;
            }
        }
      if (I > 0 && pszChars[I] == '*' && pszChars[nPrevI] == '/')
        {
          DEFINE_BLOCK (nPrevI, COLORINDEX_COMMENT);
          dwCookie |= COOKIE_EXT_COMMENT;
          bWasCommentStart = TRUE;
          continue;
        }

      bWasCommentStart = FALSE;

      if (bFirstChar)
        {
          if (pszChars[I] == '#')
            {
              DEFINE_BLOCK (I, COLORINDEX_PREPROCESSOR);
              dwCookie |= COOKIE_PREPROCESSOR;
              continue;
            }
          if (!xisspace (pszChars[I]))
            bFirstChar = FALSE;
        }

      if (pBuf)
      if (xisalnum (pszChars[I]) || pszChars[I] == '.' && I > 0 && (!xisalpha (pszChars[nPrevI]) && !xisalpha (pszChars[I + 1])))
        {
          if (nIdentBegin == -1)
            nIdentBegin = I;
        }
      else
        {
          if (nIdentBegin >= 0)
            {
              if (LangCpp::IsCppKeyword (pszChars + nIdentBegin, I - nIdentBegin))
                {
                  DEFINE_BLOCK (nIdentBegin, COLORINDEX_KEYWORD);
                }
              else if (LangCpp::IsUser1Keyword (pszChars + nIdentBegin, I - nIdentBegin))
                {
                  DEFINE_BLOCK (nIdentBegin, COLORINDEX_USER1);
                }
              else if (LangCpp::IsCppNumber (pszChars + nIdentBegin, I - nIdentBegin))
                {
                  DEFINE_BLOCK (nIdentBegin, COLORINDEX_NUMBER);
                }
              else
                {
                  bool bFunction = FALSE;

                  for (int j = I; j < nLength; j++)
                    {
                      if (!xisspace (pszChars[j]))
                        {
                          if (pszChars[j] == '(')
                            {
                              bFunction = TRUE;
                            }
                          break;
                        }
                    }
                  if (bFunction)
                    {
                      DEFINE_BLOCK (nIdentBegin, COLORINDEX_FUNCNAME);
                    }
                }
              bRedefineBlock = TRUE;
              bDecIndex = TRUE;
              nIdentBegin = -1;
            }
      }
    }

  if (nIdentBegin >= 0)
    {
      if (LangCpp::IsCppKeyword (pszChars + nIdentBegin, I - nIdentBegin))
        {
          DEFINE_BLOCK (nIdentBegin, COLORINDEX_KEYWORD);
        }
      else if (LangCpp::IsUser1Keyword (pszChars + nIdentBegin, I - nIdentBegin))
        {
          DEFINE_BLOCK (nIdentBegin, COLORINDEX_USER1);
        }
      else if (LangCpp::IsCppNumber (pszChars + nIdentBegin, I - nIdentBegin))
        {
          DEFINE_BLOCK (nIdentBegin, COLORINDEX_NUMBER);
        }
      else
        {
          bool bFunction = FALSE;

          for (int j = I; j < nLength; j++)
            {
              if (!xisspace (pszChars[j]))
                {
                  if (pszChars[j] == '(')
                    {
                      bFunction = TRUE;
                    }
                  break;
                }
            }
          if (bFunction)
            {
              DEFINE_BLOCK (nIdentBegin, COLORINDEX_FUNCNAME);
            }
        }
    }

  if (pszChars[nLength - 1] != '\\' || m_pTextBuffer->IsMBSTrail(nLineIndex, nLength - 1))
    dwCookie &= COOKIE_EXT_COMMENT;
  return dwCookie;
}
