///////////////////////////////////////////////////////////////////////////
//  File:    syntaxbase.h
//
////////////////////////////////////////////////////////////////////////////

#include "../../SyntaxColors.h"

#pragma once
  
#define DEFINE_BLOCK(pos, colorindex)   \
ASSERT((pos) >= 0 && (pos) <= nLength);\
if (pBuf && (!nActualItems || pBuf[nActualItems - 1].m_nCharPos <= (pos))){\
    pBuf[nActualItems].m_nCharPos = (pos);\
    pBuf[nActualItems].m_nColorIndex = (colorindex);\
    pBuf[nActualItems++].m_nBgColorIndex = COLORINDEX_BKGND;}

#define COOKIE_COMMENT          0x0001
#define COOKIE_PREPROCESSOR     0x0002
#define COOKIE_EXT_COMMENT      0x0004
#define COOKIE_STRING           0x0008
#define COOKIE_CHAR             0x0010

#define REAL_SUFFIX_MARK '.'

class LangSyntaxBase
{
  static bool MatchSuffix(LPCTSTR pszChars, LPCTSTR sLongSuffix, bool bReal = false, int nLength = 0);
protected:
  static BOOL IsXKeyword(LPTSTR apszKeywords[], LPCTSTR pszChars, bool caseInsensitive = false, int nLength = 0);
  static BOOL IsNumber(LPCTSTR pszChars, int nLength = 0);
  static BOOL IsNumber2(LPCTSTR pszChars, LPCTSTR sHexPrefix = NULL, LPCTSTR sLongSuffix = NULL, bool bRealAllowed = false, int nLength = 0);
};
