/* charsets.h -- character set information and mappings

  (c) 1998-2003 (W3C) MIT, ERCIM, Keio University
  See tidy.h for the copyright notice.

  $Id: charsets.h 3841 2006-11-23 17:54:41Z kimmov $

* Changes 2005-01-09 Jochen Tucht
  This file originates from the Tidy library (tidy.sourceforge.net).
  Dependencies on other parts of the library have been removed to make it
  easily plug into a Win32 application that does not use Tidy elsewhere.
  Runtime-allocated index arrays have been added to improve lookup speed.
*/

#ifndef _CHARSETS_H_
#define _CHARSETS_H_

#ifdef __cplusplus
extern "C" {
#endif

unsigned GetEncodingIdFromName(const char *name);
unsigned GetEncodingIdFromCodePage(unsigned cp);
unsigned GetEncodingCodePageFromName(const char *name);
unsigned GetEncodingCodePageFromId(unsigned id);
const char *GetEncodingNameFromId(unsigned id);
const char *GetEncodingNameFromCodePage(unsigned cp);

void charsets_cleanup(void);

#ifdef __cplusplus
}
#endif

#endif // _CHARSETS_H_
